07/03/2010  Joe Chuma <joe.chuma@gmail.com>

	v4.4.4

	* modified src/Utilities/ExGlobals
	fixed a bug in the calculation of the world and monitor units after a change in the
	aspect ratio

	* modified src/Graphics/GRA_postscript
	removed a "fudge factor" in the location for drawing text (related to preceeding fix)
	
05/02/2010  Joe Chuma <joe.chuma@gmail.com>

	v4.4.3

	* added 3D graphing speed button to the visualization window
	which allows the user to plot (x,y,z) data on basic graph axes, with the ability to zoom in/out
	and rotate in 3 dimensions.

	* enabled figure drawing speed button to the visualization window
	which allows the user to interactively draw various types of arrows, polygons, and ellipses

03/12/2009  Joe Chuma <joe.chuma@gmail.com>

	v4.4.2

	* modified the entire Help file structure, reorganizing and simplifying (and
	correcting in some cases).

	* modified src/Commands/CMD_graph
	Autoscaling one axis while the other was fixed, was causing problems.  This has been fixed.

	* modified src/Utilities/ExGlobals
	The locations of the Help and Images directories have finally been rationalized.
	
05/10/2009  Joe Chuma <joe.chuma@gmail.com>

	v4.4.1

	* modified src/Graphics/GRA_postscript
	PostScript output of graphs with an automatic graph legend were not producing all the
	proper line widths. This should now be fixed. 
	
26/09/2009  Joe Chuma <joe.chuma@gmail.com>

	v4.4.0

	* modified the fit gui src/wxForms/FitForm
	the parameter errors displayed on the resultant graph are now the more usual standard
	errors (E1), instead of the so-called "reduced standard errors" (E2)
	where E2 = E1/sqrt(chi-sq/#degrees_of_freedom).  I appologize for any confusion this
	may have caused.

	* added two new general characteristics: BACKGROUNDCOLOR and BACKGROUNDFILE
	these control the background for each graphics sub-window.
	BACKGROUNDFILE refers to a png image file.
	The default background color is white.

	* added two new general characteristics: ARROWHEADWIDTH and ARROWHEADLENGTH
	these are scale factors which are applied to the width and length of any arrow
	heads drawn with the FIGURE command, e.g., to double the width, SET ARROWHEADWIDTH 2
	while to halve it, SET ARROWHEADWIDTH 0.5   The default for both characteristics is 1.0

06/02/2008  Joe Chuma <chuma@triumf.ca>

	v4.3.6

	* modified src/wxForms/CommandTextCtrl.cpp
	the cursor is now positioned at the end of the command line on a command line recall
	with the up/down arrow keys

	* modified src/Utilities/UsefulFunctions.cpp
	initial indexing for linear interpolation was off by one causing incorrect results in
	some cases

30/01/2008  Joe Chuma <chuma@triumf.ca>

	v4.3.5

	* modified src/Graphics/GRA_window.cpp
	the REPLOT command was failing for some cases of XLOGBASE or YLOGBASE > 1, this is fixed.

	* modified src/Graphics/GRA_cartesianAxes.cpp
	the GRAPH command was failing if autoscaling was on and a linear axis was drawn first,
	with large max value, and then logbase set > 1, and GRAPH drawn again, this is fixed.

	* modified src/Graphics/GRA_cartesianAxes.cpp, src/Commands/CMD_scales.cpp
	setting the virtual min/max was not working properly when the number of large increments
	was set to zero.  This is fixed.

	* modified src/Graphics/GRA_postscript,GRA_font,GRA_fontControl
	attempting to rationalize the linux and windows fonts. Now both version try to use
	the same fonts.  Changed the font names used in PostScript output for better results.

	* modified many files
	to fix up unicode stream output when saving a session
	
11/01/2008  Joe Chuma <chuma@triumf.ca>

	v4.3.4

	* modified src/Expression/Expression.cpp, Workspace.cpp
	the FIT command was failing when the fit expression was an evaluatable text string, e.g.,
	FIT y=EVALUATE(f)  or  FIT y=1*f   where f is a string variable, this has been fixed

08/01/2008  Joe Chuma <chuma@triumf.ca>

	v4.3.3

	* modified src/Graphics/GRA_window.cpp
	the REPLOT command was failing when the axis min > max, now fixed

	* modified src/Commands/CMD_read.cpp
	when reading data from a file into vectors, a record in the data file which begins
	with the comment character, default '!', will be ignored

	* modified help files
	attempting better explanation of expression variables in the Introduction

07/01/2008  Joe Chuma <chuma@triumf.ca>

	v4.3.2

	* modified several source files to accomodate gcc v4.3 which "cleaned up" some
	header dependencies.
	
27/11/2007  Joe Chuma <chuma@triumf.ca>

	v4.3.1

	* added more polar plot characteristics, modified GRAPH\RADAR, and updated the help files.
	added characteristics: POLARAXISANGLE, POLARAXISLINEWIDTH, POLARCLOCKWISE, POLARCOMPASSLABELS
	
19/11/2007  Joe Chuma <chuma@triumf.ca>

	v4.3.0

	* added polar plots
	GRAPH\POLAR now draws a true polar plot
	polar plots have their own set of characteristics
	the help files have been updated

01/11/2007  Joe Chuma <chuma@triumf.ca>

	v4.2.10

	* modified src/Commands/CMD_read
	when reading a matrix where the number of columns is not given, extrema was
	returning 1000 columns, which is obviously wrong.  This has been fixed.

	* modified all help files
	removed extraneous Windows specific stuff from the html help files
	and tried to fix up broken links and incorrect information

	* modified src/Functions/FCN_integral
	added trapezoid rule calculation. Syntax:   INTEGRAL(x,y,'TRAPEZOID')
	
05/10/2007  Joe Chuma <chuma@triumf.ca>

	v4.2.9

	* modified src/Utilities/ExGlobals
	can now pass a script and parameters as command line arguments.  This script 
	will be executed immediately.  For example:
	$ extrema --script "testIt.pcm 50 90 'some <alpha,beta,gamma> string'"
	will execute the script testIt.pcm with 3 parameters.

14/09/2007  Joe Chuma <chuma@triumf.ca>

	v4.2.8

	* modified src/Utilities/ExXML, src/Utilities/ExGlobals
	removed dependency on libxml2, now using wxXmlDocument, wxXmlNode

	* modified Command, FCN_adev, FCN_mean, FCN_gmean, FCN_rms, FCN_skew, FCN_stdev,
	CMD_get, CMD_read, CMD_scalar, CMD_set, FCN_date, FCN_time, GRA_axis, ExSpinCtrlD.h,
	ExSpinCtrlI.h, and ExColorCtrl.h  to comply with the latest gcc compiler.

	* added FCN_heaviside                                    0.0  for x < 0
	The Heaviside function has been added.   HEAVISIDE(x) =  0.5  for x = 0
	                                                         1.0  for x > 0

17/08/2007  Joe Chuma <chuma@triumf.ca>

	v4.2.7

	* added src/wxForms/LegendPopup
	New context sensitive options.  If you right-click on a graph legend, a form
	pops up allowing you to modify aspects of the legend, such as position, size,
	frame colour, title colour, etc.

	* modified src/Utilities/ExGlobals
	New feature.  A command line beginning with the % character is now interpreted
	as a system command, e.g., %ls.  The output from the command will be displayed
	in the terminal window.
	
01/08/2007  Joe Chuma <chuma@triumf.ca>

	v4.2.6

	* added src/wxForms/TextPopup
	New context sensitive options.  If you right-click on a drawn text string,
	a form pops up allowing you to modify aspects of the text string, such as
	color, height, font, location, etc.

	* modified src/Commands/CMD_write
	Writing a text string to a file was writing gibberish instead, due to a
	unicode confusion.  This has been fixed.  Also, writing a scalar to a
	file was failing with a complaint that it wasn't a vector.  This has also
	been fixed.

27/07/2007  Joe Chuma <chuma@triumf.ca>

	v4.2.5

	* modified src/Graphics/GRA_window.cpp
	Fixed up replot for commensurate autoscaling.

	* added src/wxForms/CurvePopup, src/wxForms/ExColorCtrl,ExSpinCtrlD,ExSpinCtrlI.
	New context sensitive options.  If you right-click on a data curve on a graph,
	a form pops up allowing you to modify aspects of the curve, such as 
	histogram type, line type, line thickness, plotsymbol type, color, size, etc.
	
10/07/2007  Joe Chuma <chuma@triumf.ca>

	v4.2.4

	* added src/wxForms/AxisPopup, src/wxForms/BasicColors
	New context sensitive options.  If you right-click on the x- or y-axis
	of a graph, a form pops up allowing you to modify many axis characteristics,
	including color, location, scales, grid lines, tic marks, etc.
	This new feature will be extended to other graphical objects soon.

06/06/2007  Joe Chuma <chuma@triumf.ca>

	v4.2.3

	* modified src/wxForms/VisualizationSpeedButtonPanel
	Minor bug fix for PostScript output: if the .eps extension was not
	supplied, the plot file was created but not completed.  If the .eps
	extension was supplied, everything was ok.  This is now fixed.

	* modified src/Commands/CMD_graph
	Minor bug fix:  if the legend is off and a string is supplied as the
	first argument to the GRAPH command, an error occurred.  The string
	is now ignored, as specified in the documentation.
	
04/06/2007  Joe Chuma <chuma@triumf.ca>

	v4.2.2

	* added src/Commands/CMD_ellipse
	New command ELLIPSE can be used to populate an ellipse given the major- and
	minor-axes, centre, and angle; or it can be used to fit an ellipse to a
	set of data.  The Help files have also been updated.

	* added src/Commands/CMD_polygon
	New command POLYGON takes the coordinates for a polygon and some data coordinates,
	and returns a vector indicating which data points are inside/outside the polygon.
	The Help files have also been updated.

15/05/2007  Joe Chuma <chuma@triumf.ca>

	v4.2.1

	* modified src/wxForms/VisualizationWindow, SetAspectRatioForm
	Minor changes to allow linking with wxGTK v2.6.3
	
	* modified src/wxForms/VisualizationWindow, src/Utilities/ExGlobals,
	src/wxForms/SetAspectRatioForm.  Minor fixes for aspect ratio changes,
	hidden pages were not being reset properly.

	* added src/Commands/CMD_alias, CMD_dealias.
	New command ALIAS allows the user to create new commands out of the
	current commands.  New command DEALIAS is used to remove an alias.
	
08/05/2007  Joe Chuma <chuma@triumf.ca>

	v4.2.0
	
	* added src/wxForms/GraphicsPage, src/Commands/CMD_page.  These allow for
	multiple graphics pages in a tabbed format.  A new graphics page adds another
	tab in the visualization window.  Use the speed buttons on the visualization
	window, or the PAGE command, to add/remove pages.

	* added src/wxForms/SetAspectRatioForm.  This allows for interactively changing
	the aspect ratio.
	
	* modified src/Utilities/ExGlobals, src/wxForm/VisualizationWindow to fix up
	the SAVE/RESTORE feature for multiple graphics pages.
	
	* modified src/Graphics/GRA_postscript to break up long sets of "lineto"s in
	order to speed up ghostview display of postscript files, also included shorter
	names for "lineto", "moveto", and "stroke", to make the files smaller.
	
	* modified src/Commands/CMD_get,CMD_set to modify orientation, which now
	uses aspectratio.  For letter size paper, use SET ASPECTRATIO 8.5/11 to
	get landscape orientation, and use SET ASPECTRATIO 11/8.5 to get portrait
	orientation.

18/04/2007  Joe Chuma <chuma@triumf.ca>

	v4.1.10

	* added src/Functions/FCN_asinh,FCN_acosh,FCN_atanh,FCN_asech,FCN_acsch,FCN_acoth,
	FCN_cosh,FCN_sinh,FCN_tanh,FCN_sech,FCN_csch,FCN_coth the hyperbolic trig
	functions (I simply forgot to include them before)

	* added src/Graphics/GRA_postscript (a PostScript driver) to fix up the PostScript
	output, i.e., it is now encapsulated postscript (with a bounding box), and the
	Greek characters and the math symbols should now appear in the postscript output

	
30/03/2007  Joe Chuma <chuma@triumf.ca>

	v4.1.9

	* modified src/Commands/CMD_execute to fix a bug in appending the current
	path to a filename.  The / was missing before the filename.

	* modified src/Commands/CMD_inquire,CMD_execute,CMD_text,CMD_quit,CMD_if,
	CMD_pause,CMD_set,CMD_get,CMD_return and src/Graphics/GRA_drawableText and
	src/Parsing/Script and src/Utilities/ExGlobals and
	src/wxForms/AnalysisMessagePanel,CommandTextCtrl,ExecuteDialog,
	VisualizationWindow,AnalysisWindow to fix script handling.  Previously,
	nested scripts were simply not handled correctly, leading to stack overflow
	or other serious problems.  It should now be fixed.

	* added src/Functions/FCN_skew,FCN_mean,FCN_var,FCN_stdev,FCN_rms,FCN_median,
	FCN_kurt,FCN_imin,FCN_imax,FCN_gmean,FCN_adev so the various statistics
	can be obtained easier than via the STATISTICS command.

	* modified src/Functions/FCN_time,FCN_date to fix more bugs in the TIME
	and DATE functions.
	
27/03/2007  Joe Chuma <chuma@triumf.ca>

	v4.1.8 (for various reasons, 4.1.8 was skipped)
	
06/03/2007  Joe Chuma <chuma@triumf.ca>

	v4.1.7

	* modified src/Graphics/GRA_axis to fix a bug with log scales when
	there are no major tic marks showing

	* modified src/Commands/CMD_fit to fix a bug with the \CL qualifier
	not being recognized

	* added optional support for MINUIT (minimization code from CERN)

	* modified src/Commands/CMD_scalar to allow limits on fit parameters
	destined for use in MINUIT, e.g., SCALAR\FIT A[min:max].  These limits
	are ignored by the FIT command.

	* modified src/Graphics/GRA_ditheringPlot, GRA_gradientPlot and
	src/Parsing/ParseLine to remove un-named temporary to be passed as a reference
	to const argument to a function.

	* modified src/Utilities/ExGlobals to fix a bug with the PAUSE command.
	A pause in a second level macro (one called by another macro)  was causing
	all scripts to stop after the pause.

	* modified src/Graphics/GRA_axis to fix a bug in drawing a linear axis
	when the virtual min and/or max are within the axis min/max.
	
08/02/2007  Joe Chuma <chuma@triumf.ca>

	v4.1.6

	* modified src/Commands/CMD_hardcopy so that the file path defaults to the
	current directory

	* modified src/Functions/FCN_date and src/Functions/FCN_time so that they
	work and not seg.fault.

	* modified Help/html/Functions/StringManipulation/time.htm to fix an error
	in the description of the format

	* modified src/Commands/CMD_statistics to fix the calculation of the median

	* modified src/Parsing/ParseLine to fix a bug so that a qualifier can
	be appended to a variable with indices, e.g., STAT X XM[1]\MEAN
	
	* modified src/Commands/CMD_text and src/wxForms/VisualizationWindow to
	fix a problem with interactive text placement from within a script

	* modified src/Utilities/ExGlobals, src/wxForms/HintForm, and
	src/wxForms/VisualizationWindow to fix up the hint window for interactive
	text placement

	* upgraded to wxGTK-2.8.0
	
24/01/2007  Joe Chuma <chuma@triumf.ca>

	v4.1.5

	* added  extrema.spec extrema.desktop extrema_icons.tar.bz2 to the distribution
	
	* modified src/Command/CMD_set and src/Utilities/ExGlobals to add ECHOON
	characteristic.  ECHOON controls whether an executing script is displayed
	in the command history and message window.

	* modified src/Commands/CMD_read and src/Commands/CMD_write so that the
	file path defaults to the current directory.

	* modified src/Commands/CMD_set to fix a bug when setting AUTOSCALE ON\VIRTUAL

	* modified src/Commands/CMD_destroy, src/Variables/TextVariable and
	src/Variables/TVariableTable to fix a bug when DESTROYing a text variable
	or when DESTROYing an element of an array text variable

	* modified src/Commands/CMD_graph to fix an autoscaling bug

	* modified src/Parsing/ParseLine to fix not parsing properly a qualifier
	after a closing bracket, e.g. STATISTICS X XM[1]\MEAN

	* modified src/Graphics/GRA_cartesianAxes to fix replot of log scales when
	autoscale is off
	
19/01/2007  Joe Chuma <chuma@triumf.ca>

	v4.1.4

	* renamed extremaHelp/ back to Help/ and extremaImages/ back to /Images
	These directories will now be placed, by default, in /usr/local/share/extrema/

	* Makefile.am : added fonts/ directory to the distribution
	These TrueType fonts are freely available, but the user must install them.
	The SYMBOL font is neccessary for the special symbols such as <alpha>, <beta>, etc.

	* fixed the QUIT command so the quit dialog only has "Yes" and "No" buttons
	and if you click "No", the program does not quit
	
	* modified src/Functions/FCN_iclose.cpp
	default calculated index was initialised to 1 instead of 0

	* added new characteristic MAXHISTORY
	MAXHISTORY controls how many history records are stored for each variable

	* modified src/wxForms/FontChooser.h
	added #include "wx/notebook.h"

	* modified src/wxForms/FitForm.h
	changed 'std::size_t nFree_;'  to  'unsigned int nFree_;'

	* modified src/Commands/CMD_fit.cpp
	changed 'std::size_t nfree=0;'  to  'unsigned int nfree=0;'

	* modified src/wxForms/AnalysisWindow.h
	removed member function 'GetPointer'
	
11/01/2007  Joe Chuma <chuma@triumf.ca>
	
	v4.1.3
	
	* renamed Help/ to extremaHelp/  and  Images/ to extremaImages/
	
	* Makefile.am : added extremaHelp/ and extremaImages/ to $(prefix)/share directory (make install)
	added extremaHelp/, extremaImages/, Scripts/, and doc/ to distribution tar file (make dist)
		    
	* modified src/Commands/CMD_density.h, src/Commands/Command.h, src/Functions/ScalarFunction.h, and
	src/Graphics/GRA_window.h to remove extraneous class qualifiers, as more recent compilers
	complain about this (submitted by S.Umar)

	* modified src/Utilities/ExGlobals.h and .cpp to rationalize the locations for the help and image
	files they now go to $(prefix)/share with "make install"
	also modified VisualizationSpeedButtonPanel.cpp, PeakFindForm.cpp, ChooseFilePanel.cpp, and
	AnalysisSpeedButtonPanel.cpp to accommodate the new image file location

	* modified src/Graphics/GRA_axis.cpp to fix the grid line color	

------------------------------------------------------------------------------------------------------------
Copyright (C) 2006, 2007 Joseph L. Chuma <chuma@triumf.ca>
Copying and distribution of this file, with or without modification, are
permitted, provided the copyright notice and this notice are preserved.
